package ca.ualberta.xdong.plasMapper.annotate;


/**
 *
 * Defines a Open reading frame for a protein sequence.
 * It defines start position, stop position, frame index
 * of the opene reading frame on a protein sequence 
 * 
 * @author xdong
 */

public class OpenReadingFrame implements Comparable {

	private int start;
	private int stop;
	private int frameIndex;
	private String proteinSeq;

	public OpenReadingFrame(
		int start,
		int stop,
		String proteinSeq,
		int frameIndex) {
		this.start = start;
		this.stop = stop;
		this.proteinSeq = proteinSeq;
		this.frameIndex = frameIndex;
	}

	public int getLength() {

		return this.stop - this.start;

	}
	public int getStart() {

		return start;
	}

	public int getStop() {

		return this.stop;
	}
	public int getFrameIndex() {

		return this.frameIndex;
	}
	public String getProteinSeq() {

		return proteinSeq;
	}
	public String toString() {

		String str = "(" + start + "," + stop + "," + frameIndex + ")";
		return str;
	}

	public int compareTo(Object orf) {

		if (this.getLength() > ((OpenReadingFrame) orf).getLength())
			return 1;
		else if (this.getLength() < ((OpenReadingFrame) orf).getLength())
			return -1;
		else
			return 0;

	}
}
