package ca.ualberta.xdong.plasMapper.annotate;
import java.util.*;
import java.io.*;

/**
 * 
 * @author xdong
 */

public class Utility {
	public Utility() {
		;
	}
	public String getPath(String key) throws Exception {

		InputStream is =
			this.getClass().getResourceAsStream(
				"plasMapConfiguration_en_CA.properties");
		Properties properties = new Properties();
		properties.load(is);
		String path = properties.getProperty(key);
		return path;
	}

	//read file but remove \n
	public static StringBuffer readString(String file) throws Exception {

		//readFile from a file
		StringBuffer buffer = new StringBuffer(1000);
		String str;
		try {

			BufferedReader br = new BufferedReader(new FileReader(file));
			while ((str = br.readLine()) != null) {
				String temp = str.trim();
				if (temp.indexOf(">") < 0)
					buffer.append(temp);
			}

			br.close();
		} catch (FileNotFoundException fnfe) {
			System.out.println(fnfe);

		} catch (IOException ioe) {
			System.out.println(ioe);
		}
		return buffer;
	}

	//read file but remove \n
	public static StringBuffer parseRebaseFormat31(String file)
		throws Exception {

		//readFile from a file
		StringBuffer buffer = new StringBuffer(1000);
		String str;
		try {

			BufferedReader br = new BufferedReader(new FileReader(file));
			int counter = 0;
			while ((str = br.readLine()) != null) {

				if (str.indexOf("<2>") == 0) {
					buffer.append("<2>\n");
					counter++;

				} else
					buffer.append(str + "\n");
			}

			br.close();
		} catch (FileNotFoundException fnfe) {
			System.out.println(fnfe);

		} catch (IOException ioe) {
			System.out.println(ioe);
		}
		return buffer;
	}

	public static String removeUselessCharacter(String seq) throws Exception {

		String finalSeq = "";

		StringTokenizer stk = new StringTokenizer(seq, "\n");
		String str = "";

		while (stk.hasMoreTokens()) {

			str = stk.nextToken();
			if (str.indexOf(">") < 0)
				finalSeq = finalSeq + str;
		}

		String seq1 = finalSeq;

		finalSeq = "";

		stk =
			new StringTokenizer(
				seq1,
				" \t\n\r\f~!@#$%^&*()_-+=[]}{\\|\'\";:/?.>,<0123456789BDEFHIJKLMNOPQRSYUWXYZbdefhijklmnopqrsuvwxyz");
		str = "";

		while (stk.hasMoreTokens()) {

			str = stk.nextToken();
			finalSeq = finalSeq + str;

		}

		return finalSeq;
	}

	/*
	seq is a string sequence there is no space inside
	format seq into format of fasta
	*/
	public static String formatToFasta(String seq) throws Exception {

		String formatStr = "";
		int size = seq.length();

		int index = 0;
		String str = "";

		while (index < size - 60) {
			str = "";
			str = seq.substring(index, index + 60);
			formatStr = formatStr + str + "\n";
			index = index + 60;
		}

		if (index < size) {
			str = seq.substring(index);
			formatStr = formatStr + str;
		}
		return formatStr;
	}

	/*
	seq is a string sequence there is no space inside
	format seq into format of
	"1 aaaaaaaaaaaaaaaaaaaaaaaaa...a 60"
	*/
	public static String format(String seq) throws Exception {

		String formatStr = "";
		int size = seq.length();

		int index = 0;
		String str = "";
		int startPos = 0;
		int endPos = 0;
		String startStr = "";

		while (index < size - 60) {
			str = "";
			startPos = index + 1;
			endPos = index + 60;

			if (startPos < 10)
				startStr = startPos + "    ";
			else if (startPos < 100)
				startStr = startPos + "   ";
			else if (startPos < 1000)
				startStr = startPos + "  ";
			else if (startPos < 10000)
				startStr = startPos + " ";

			//str = seq.substring(index, index+60);
			for (int j = 0; j < 6; j++) {
				str =
					str
						+ " "
						+ seq.substring(index + j * 10, index + (j + 1) * 10);

			}

			formatStr =
				formatStr + startStr + "  " + str + "  " + endPos + "\n";
			index = index + 60;
		}

		if (index < size) {
			int i = index;
			str = "";
			while (i < size - 10) {

				str = str + " " + seq.substring(i, i + 10);
				i = i + 10;
			}

			if (i < size)
				str = str + " " + seq.substring(i);

			startPos = index + 1;

			if (startPos < 10)
				startStr = startPos + "    ";
			else if (startPos < 100)
				startStr = startPos + "   ";
			else if (startPos < 1000)
				startStr = startPos + "  ";
			else if (startPos < 10000)
				startStr = startPos + " ";

			formatStr = formatStr + startStr + "  " + str + "  " + size;
		}
		return formatStr;
	}

}
