package ca.ualberta.xdong.plasMapper.servlet;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import ca.ualberta.stothard.cgview.*;
import ca.ualberta.xdong.plasMapper.annotate.*;
import com.oreilly.servlet.MultipartRequest;

/**
 * 
 * @author xdong
 * A small addition was made to accomodate BioMoby integration --pjs
 *
 */
public class DrawVectorMap extends HttpServlet {
	
	private static final long serialVersionUID = 1L;
	public static int hitNum = 0;

	public void doPost(
		HttpServletRequest request,
		HttpServletResponse response)
		throws IOException, ServletException {

		try {

			hitNum++;
			Date date = new Date();
			long timeStr = date.getTime();

			Utility util = new Utility();
			String plasMapRoot = util.getPath("plasMapRoot");
			String tmpDir = plasMapRoot + File.separator + "tmp/";

			MultipartRequest multi =
				new MultipartRequest(request, tmpDir, 2 * 1024 * 1024);
			String sequence = multi.getParameter("sequence");

			//Feature options
			String[] options = multi.getParameterValues("showOption");

			//Restriction options
			String restriction = multi.getParameter("restriction");

			//Open reading frame
			String orfLen = multi.getParameter("orfLen");
			String[] strands = multi.getParameterValues("strand");

			//User defined function
			String featureName1 = multi.getParameter("featureName1");
			String start1 = multi.getParameter("start1");
			String stop1 = multi.getParameter("stop1");
			String featureCategory1 = multi.getParameter("category1");
			String dir1 = multi.getParameter("dir1");

			String featureName2 = multi.getParameter("featureName2");
			String start2 = multi.getParameter("start2");
			String stop2 = multi.getParameter("stop2");
			String featureCategory2 = multi.getParameter("category2");
			String dir2 = multi.getParameter("dir2");

			String featureName3 = multi.getParameter("featureName3");
			String start3 = multi.getParameter("start3");
			String stop3 = multi.getParameter("stop3");
			String featureCategory3 = multi.getParameter("category3");
			String dir3 = multi.getParameter("dir3");

			String featureName4 = multi.getParameter("featureName4");
			String start4 = multi.getParameter("start4");
			String stop4 = multi.getParameter("stop4");
			String featureCategory4 = multi.getParameter("category4");
			String dir4 = multi.getParameter("dir4");

			String featureName5 = multi.getParameter("featureName5");
			String start5 = multi.getParameter("start5");
			String stop5 = multi.getParameter("stop5");
			String featureCategory5 = multi.getParameter("category5");
			String dir5 = multi.getParameter("dir5");

			String featureName6 = multi.getParameter("featureName6");
			String start6 = multi.getParameter("start6");
			String stop6 = multi.getParameter("stop6");
			String featureCategory6 = multi.getParameter("category6");
			String dir6 = multi.getParameter("dir6");

			//graphic display option
			String imageFormat = multi.getParameter("imageFormat");
			String comment = multi.getParameter("comment");
			String label = multi.getParameter("labels");
			String labelColor = multi.getParameter("labColor");
			String imageSize = multi.getParameter("imageSize");
			String mapTitle = multi.getParameter("mapTitle");
			String legend = multi.getParameter("legend");
			String arrow = multi.getParameter("arrow");
			//String imageSize = multi.getParameter("imageSize");
			String backbone = multi.getParameter("backbone");
			String arc = multi.getParameter("arc");
			String shading = multi.getParameter("shading");
			String scheme = multi.getParameter("scheme");
			String labelBox = multi.getParameter("labelBox");
			String tickMark = multi.getParameter("tickMark");
			String innerLabels = multi.getParameter("innerLabels");
			StringTokenizer stk = new StringTokenizer(imageSize, " \t\n\r\fx");
			String str = "";
			String[] whs = new String[2];
			int counter = 0;
			while (stk.hasMoreTokens()) {
				str = stk.nextToken();
				whs[counter++] = str;
			}

			String outputFile = "output" + hitNum + "_" + timeStr + ".txt";
			String inputFile = "input" + hitNum + "_" + timeStr + ".txt";
			//System.out.println(options.length);
			//if(mapTitle == null || mapTitle.length() == 0)
			//mapTitle = "Untitle";

			PlasFeatures plasFeature = null;

			//up load local file
			if (sequence == null || sequence.length() == 0) {
				Enumeration files = multi.getFileNames();
				while (files.hasMoreElements()) {
					String name = (String) files.nextElement();
					File file = multi.getFile(name);
					plasFeature =
						new PlasFeatures(
							true,
							"",
							file.getPath(),
							tmpDir + inputFile,
							tmpDir + outputFile);
					//file.delete();

				}
			} else
				plasFeature =
					new PlasFeatures(
						false,
						sequence,
						"",
						tmpDir + inputFile,
						tmpDir + outputFile);

			//Vector all = plasFeature.getAllFeatures();
			//System.out.println(all);

			Vector origin = plasFeature.getOrigin();
			Vector promoter = plasFeature.getPromoter();
			Vector regular = plasFeature.getRegulatorySeq();
			Vector tag = plasFeature.getTag();
			Vector terminator = plasFeature.getTerminator();
			Vector select = plasFeature.getSelector();
			Vector reporter = plasFeature.getReporter();
			Vector other = plasFeature.getOther();
			int vectorSize = plasFeature.getSeqLength();
			int realSeqLen = plasFeature.getSeqLength();

			if (realSeqLen > 20000)
				response.sendRedirect(
					response.encodeRedirectURL(
						"/PlasMapper/jsp/error.jsp?msg=The sequence length cannot be longer than 20000"));

			Vector orfs = new Vector(10);

			if (orfLen != null && orfLen.length() != 0) {
				orfs =
					plasFeature.getStartORFs(Integer.parseInt(orfLen), strands);
				//orfs = plasFeature.getORFs(Integer.parseInt(orfLen), strands);
				//System.out.println("OpenReadingFrame=" + orfs.toString());
			}

			Plasmid plasmid = new Plasmid(mapTitle, vectorSize);

			if (mapTitle == null || mapTitle.length() == 0)
				plasmid.setShowTitle(false);

			plasmid.setAddCategoryInfo(false);

			if (comment == null || comment.length() == 0)
				plasmid.setShowMessage(false);
			else
				plasmid.setMessage(comment);

			//no labels
			if (label.equals("0"))
				plasmid.setShowLabels(true);

			else
				plasmid.setShowLabels(false);

			//no label box
			if (labelBox.equals("0"))
				plasmid.setUseColoredLabelBackground(true);

			else
				plasmid.setUseColoredLabelBackground(false);

			//label has no color
			if (labelColor.equals("1")) {
				plasmid.setUseColoredLabels(false);
			} else
				plasmid.setUseColoredLabels(true);

			if (innerLabels.equals("0"))
				plasmid.setShowInnerLabels(true);

			else
				plasmid.setShowInnerLabels(false);

			//no legend
			if (legend.equals("1")) {
				plasmid.setShowLegend(false);
			} else
				plasmid.setShowLegend(true);

			//no arrow
			if (arrow.equals("1")) {
				plasmid.setUseArrows(false);
			} else
				plasmid.setUseArrows(true);

			//no shading
			if (shading.equals("1")) {
				plasmid.setShowShading(false);
			} else
				plasmid.setShowShading(true);

			//inverse
			if (scheme.equals("1")) {
				plasmid.setColorScheme(0);
			} else
				plasmid.setColorScheme(1);

			//inverse
			if (tickMark.equals("0")) {
				plasmid.setDrawTickMarks(true);
			} else
				plasmid.setDrawTickMarks(false);

			//backbone
			plasmid.setBackboneThickness(backbone);
			plasmid.setFeatureThickness(arc);

			plasmid.setImageWidth(Integer.parseInt(whs[0]));
			plasmid.setImageHeight(Integer.parseInt(whs[1]));

			//Add use defined feature first
			if (featureName1 != null && featureName1.length() != 0) {
				String error = "";

				if (Integer.parseInt(start1) > realSeqLen
					|| Integer.parseInt(start1) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature1 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop1) > realSeqLen
					|| Integer.parseInt(stop1) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature1 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				int temp = 0;

				if (!featureCategory1.equals("unique_restriction_site")
					&& !featureCategory1.equals("restriction_site"))
					temp = Integer.parseInt(dir1);

				plasmid.addFeature(
					featureCategory1,
					featureName1,
					Integer.parseInt(start1),
					Integer.parseInt(stop1),
					temp);
			}
			//Add use defined feature first
			if (featureName2 != null && featureName2.length() != 0) {

				String error = "";

				if (Integer.parseInt(start2) > realSeqLen
					|| Integer.parseInt(start2) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature2 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop2) > realSeqLen
					|| Integer.parseInt(stop2) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature2 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				int temp = 0;
				if (!featureCategory1.equals("unique_restriction_site")
					&& !featureCategory1.equals("restriction_site"))
					temp = Integer.parseInt(dir2);

				plasmid.addFeature(
					featureCategory2,
					featureName2,
					Integer.parseInt(start2),
					Integer.parseInt(stop2),
					temp);
			}

			//Add use defined feature first
			if (featureName3 != null && featureName3.length() != 0) {

				String error = "";

				if (Integer.parseInt(start3) > realSeqLen
					|| Integer.parseInt(start3) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature3 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop3) > realSeqLen
					|| Integer.parseInt(stop3) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature3 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				int temp = 0;
				if (!featureCategory1.equals("unique_restriction_site")
					&& !featureCategory1.equals("restriction_site"))
					temp = Integer.parseInt(dir3);
				plasmid.addFeature(
					featureCategory3,
					featureName3,
					Integer.parseInt(start3),
					Integer.parseInt(stop3),
					temp);
			}

			//Add use defined feature first
			if (featureName4 != null && featureName4.length() != 0) {

				String error = "";

				if (Integer.parseInt(start4) > realSeqLen
					|| Integer.parseInt(start4) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature4 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop4) > realSeqLen
					|| Integer.parseInt(stop4) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature4 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				int temp = 0;

				if (!featureCategory1.equals("unique_restriction_site")
					&& !featureCategory1.equals("restriction_site"))
					temp = Integer.parseInt(dir4);

				plasmid.addFeature(
					featureCategory4,
					featureName4,
					Integer.parseInt(start4),
					Integer.parseInt(stop4),
					temp);
			}
			//			Add use defined feature first
			if (featureName5 != null && featureName5.length() != 0) {

				String error = "";

				if (Integer.parseInt(start5) > realSeqLen
					|| Integer.parseInt(start5) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature5 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop5) > realSeqLen
					|| Integer.parseInt(stop5) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature5 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				int temp = 0;

				if (!featureCategory1.equals("unique_restriction_site")
					&& !featureCategory1.equals("restriction_site"))
					temp = Integer.parseInt(dir5);

				plasmid.addFeature(
					featureCategory5,
					featureName5,
					Integer.parseInt(start5),
					Integer.parseInt(stop5),
					temp);
			}
			//			Add use defined feature first
			if (featureName6 != null && featureName6.length() != 0) {

				String error = "";

				if (Integer.parseInt(start6) > realSeqLen
					|| Integer.parseInt(start6) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature6 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop6) > realSeqLen
					|| Integer.parseInt(stop6) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature6 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				int temp = 0;

				if (!featureCategory1.equals("unique_restriction_site")
					&& !featureCategory1.equals("restriction_site"))
					temp = Integer.parseInt(dir6);

				plasmid.addFeature(
					featureCategory6,
					featureName6,
					Integer.parseInt(start6),
					Integer.parseInt(stop6),
					temp);
			}
			//		
			for (int i = 0; options != null && i < options.length; i++) {

				int feature = Integer.parseInt(options[i]);

				//System.out.println("feature=" + feature);

				if (feature == 1) {
					for (int j = 0; j < origin.size(); j++) {
						FeatureSite site = (FeatureSite) origin.elementAt(j);
						plasmid.addFeature(
							"origin_of_replication",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 2) {

					for (int j = 0; j < promoter.size(); j++) {
						FeatureSite site = (FeatureSite) promoter.elementAt(j);
						plasmid.addFeature(
							"promoter",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 3) {

					for (int j = 0; j < terminator.size(); j++) {
						FeatureSite site =
							(FeatureSite) terminator.elementAt(j);
						plasmid.addFeature(
							"terminator",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 4) {

					for (int j = 0; j < select.size(); j++) {
						FeatureSite site = (FeatureSite) select.elementAt(j);
						plasmid.addFeature(
							"selectable_marker",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 5) {

					for (int j = 0; j < reporter.size(); j++) {
						FeatureSite site = (FeatureSite) reporter.elementAt(j);
						plasmid.addFeature(
							"reporter_gene",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 6) {

					for (int j = 0; j < regular.size(); j++) {
						FeatureSite site = (FeatureSite) regular.elementAt(j);
						plasmid.addFeature(
							"regulatory_sequence",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 7) {

					for (int j = 0; j < tag.size(); j++) {
						FeatureSite site = (FeatureSite) tag.elementAt(j);
						plasmid.addFeature(
							"tag",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 8) {

					for (int j = 0; j < other.size(); j++) {
						FeatureSite site = (FeatureSite) other.elementAt(j);
						plasmid.addFeature(
							"other_gene",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							Integer.parseInt(site.getDirection()));

					}
				} else if (feature == 9) {
					Vector restrictionSites = null;
					Vector ncutters = new Vector(6);

					//unique site && common enzyme
					if (restriction.equals("1")) {
						//restrictionSites = plasFeature.getUniqueRestrictionSites(ncutters);
						restrictionSites =
							plasFeature.getUniqueRestrictionSites(1);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}
					}

					//unique with >= 4cutter
					else if (restriction.equals("2")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));

						//unique common enzyme
						Vector all = plasFeature.getUniqueRestrictionSites(1);
						//unique common enzyme and <=3 cutter
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}
					}
					//unique site with >= 6cutter
					else if (restriction.equals("3")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));

						Vector all = plasFeature.getUniqueRestrictionSites(1);
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}
					}

					//all site with common enzyme
					else if (restriction.equals("4")) {

						//restrictionSites = plasFeature.getRestrictionSites();
						restrictionSites =
							plasFeature.getNotUniqueRestrictionSites(1);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);

						}

						restrictionSites =
							plasFeature.getUniqueRestrictionSites(1);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);

						}

					}

					//all site with >= 4 cutter
					else if (restriction.equals("5")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));
						//Vector all = plasFeature.getAllRestrictionSites();
						//Vector useless = plasFeature.getAllRestrictionSites(ncutters);
						Vector all =
							plasFeature.getNotUniqueRestrictionSites(1);
						Vector useless =
							plasFeature.getNotUniqueRestrictionSites(
								ncutters,
								1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

						all = plasFeature.getUniqueRestrictionSites(1);
						useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

					}
					//all site with <= 6 cutter
					else if (restriction.equals("6")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));
						//Vector all = plasFeature.getAllRestrictionSites();
						//Vector useless = plasFeature.getAllRestrictionSites(ncutters);
						//restrictionSites = removeUselessElement(all, useless);

						//for(int j = 0; j < restrictionSites.size(); j++){
						///FeatureSite site = (FeatureSite)restrictionSites.elementAt(j);
						//plasmid.addFeature("restriction_site",site.getLabel(), site.getStart(),site.getEnd(),0);
						//}

						Vector all =
							plasFeature.getNotUniqueRestrictionSites(1);
						Vector useless =
							plasFeature.getNotUniqueRestrictionSites(
								ncutters,
								1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

						all = plasFeature.getUniqueRestrictionSites(1);
						useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

					}
					//unique site && all enzyme
					else if (restriction.equals("7")) {
						//restrictionSites = plasFeature.getUniqueRestrictionSites(ncutters);
						restrictionSites =
							plasFeature.getUniqueRestrictionSites(0);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}
					}

					//unique with >= 4cutter and all enzyme
					else if (restriction.equals("8")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));

						//unique common enzyme
						Vector all = plasFeature.getUniqueRestrictionSites(0);
						//unique common enzyme and <=3 cutter
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}
					}
					//unique site with >= 6cutter and all enzyme
					else if (restriction.equals("9")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));

						Vector all = plasFeature.getUniqueRestrictionSites(0);
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}
					}

					//all site with common enzyme
					else if (restriction.equals("10")) {

						//restrictionSites = plasFeature.getRestrictionSites();
						restrictionSites =
							plasFeature.getNotUniqueRestrictionSites(0);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);

						}

						restrictionSites =
							plasFeature.getUniqueRestrictionSites(0);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);

						}

					}

					//all site with >= 4 cutter
					else if (restriction.equals("11")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));
						//Vector all = plasFeature.getAllRestrictionSites();
						//Vector useless = plasFeature.getAllRestrictionSites(ncutters);
						Vector all =
							plasFeature.getNotUniqueRestrictionSites(0);
						Vector useless =
							plasFeature.getNotUniqueRestrictionSites(
								ncutters,
								0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

						all = plasFeature.getUniqueRestrictionSites(0);
						useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

					}
					//all site with <= 6 cutter
					else if (restriction.equals("12")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));
						//Vector all = plasFeature.getAllRestrictionSites();
						//Vector useless = plasFeature.getAllRestrictionSites(ncutters);
						//restrictionSites = removeUselessElement(all, useless);

						//for(int j = 0; j < restrictionSites.size(); j++){
						///FeatureSite site = (FeatureSite)restrictionSites.elementAt(j);
						//plasmid.addFeature("restriction_site",site.getLabel(), site.getStart(),site.getEnd(),0);
						//}

						Vector all =
							plasFeature.getNotUniqueRestrictionSites(0);
						Vector useless =
							plasFeature.getNotUniqueRestrictionSites(
								ncutters,
								0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

						all = plasFeature.getUniqueRestrictionSites(1);
						useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							plasmid.addFeature(
								"unique_restriction_site",
								site.getLabel(),
								site.getStart(),
								site.getEnd(),
								0);
						}

					}
				}

			}

			for (int j = 0; j < orfs.size(); j++) {

				FeatureSite site = (FeatureSite) orfs.elementAt(j);

				for (int i = 0; strands != null && i < strands.length; i++) {

					int strand = Integer.parseInt(strands[i]);

					if (strand == Integer.parseInt(site.getDirection())) {

						//System.out.println("OpenReadingFrame=" + site.getLabel());
						plasmid.addFeature(
							"open_reading_frame",
							site.getLabel(),
							site.getStart(),
							site.getEnd(),
							strand);
						//System.out.println("direction orf=" + strand);
						//locations.add(new FeatureSite(site));
					}
				}
			}

			String url = "";

			String fileName = "plasMap" + hitNum + "_" + timeStr;

			if (imageFormat.equals("PNG")) {

				plasmid.writeToPNGFile(tmpDir + fileName + ".png");

				url =
					"/PlasMapper/jsp/displayPlasmidMap.jsp?fileName="
						+ fileName
						+ ".png&fileFormat=png";
			} else if (imageFormat.equals("JPG")) {
				//response.setContentType("image/jpg");

				plasmid.writeToJPGFile(tmpDir + fileName + ".jpg");
				url =
					"/PlasMapper/jsp/displayPlasmidMap.jsp?fileName="
						+ fileName
						+ ".jpg&fileFormat=jpg";

			} else if (imageFormat.equals("SVG")) {
				//response.setContentType("image/svg+xml");
				plasmid.writeToSVGFile(tmpDir + fileName + ".svg");

				url =
					"/PlasMapper/jsp/displayPlasmidMap.jsp?fileName="
						+ fileName
						+ ".svg&fileFormat=svg";
			} else if (imageFormat.equals("SVGZ")) {

				plasmid.writeToSVGZFile(tmpDir + fileName + ".svgz");

				url =
					"/PlasMapper/jsp/displayPlasmidMap.jsp?fileName="
						+ fileName
						+ ".svgz&fileFormat=svgz";
			}

            /* BioMoby Integration Changes Start Here */
            String biomoby = multi.getParameter("biomoby");
            if (biomoby == null)
            {
			    response.sendRedirect(response.encodeRedirectURL(url));
            }
            else
            {
                response.setContentType("text/plaintext");
                PrintWriter out = response.getWriter();
                out.println("/PlasMapper/tmp/" + fileName + "." + imageFormat.toLowerCase());
                out.close();
            }
            /* BioMoby Integration Changes End Here */

			//PrintWriter out = response.getWriter();
			//out.println(buffer.toString());

		} catch (java.lang.Exception ex) {
			ex.printStackTrace();
			ex.getMessage();
		}

	}
	protected void doGet(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {

		doPost(request, response);
	}

	private Vector removeUselessElement(Vector all, Vector partial) {

		Vector left = new Vector(10);

		for (int i = 0; i < all.size(); i++) {

			FeatureSite site = (FeatureSite) all.elementAt(i);
			String name = site.getLabel();

			boolean found = false;

			for (int j = 0; j < partial.size(); j++) {

				FeatureSite temp = (FeatureSite) partial.elementAt(j);

				if (name.equals(temp.getLabel()))
					found = true;

			}

			if (!found)
				left.add(site);
		}

		return left;

	}
}
