package ca.ualberta.xdong.plasMapper.servlet;

import ca.ualberta.xdong.plasMapper.annotate.*;
import com.oreilly.servlet.MultipartRequest;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * 
 * @author xdong
 * A small addition was made to accomodate BioMoby integration --pjs
 * 
 */
public class TextMap extends HttpServlet {
	
	private static final long serialVersionUID = 1L;
	public static int hitNum = 0;
	public void doPost(
		HttpServletRequest request,
		HttpServletResponse response)
		throws IOException, ServletException {

		try {

			hitNum++;
			Date date = new Date();
			long timeStr = date.getTime();

			Utility util = new Utility();
			String plasMapRoot = util.getPath("plasMapRoot");
			String tmpDir = plasMapRoot + File.separator + "tmp/";

			MultipartRequest multi =
				new MultipartRequest(request, tmpDir, 2 * 1024 * 1024);
			String sequence = multi.getParameter("sequence");

			//Feature options
			String[] options = multi.getParameterValues("showOption");

			//Restriction options
			String restriction = multi.getParameter("restriction");

			//Open reading frame
			String orfLen = multi.getParameter("orfLen");
			String[] strands = multi.getParameterValues("strand");

			//User defined function
			String featureName1 = multi.getParameter("featureName1");
			String start1 = multi.getParameter("start1");
			String stop1 = multi.getParameter("stop1");
			String featureCategory1 = multi.getParameter("category1");
			String dir1 = multi.getParameter("dir1");

			String featureName2 = multi.getParameter("featureName2");
			String start2 = multi.getParameter("start2");
			String stop2 = multi.getParameter("stop2");
			String featureCategory2 = multi.getParameter("category2");
			String dir2 = multi.getParameter("dir2");

			String featureName3 = multi.getParameter("featureName3");
			String start3 = multi.getParameter("start3");
			String stop3 = multi.getParameter("stop3");
			String featureCategory3 = multi.getParameter("category3");
			String dir3 = multi.getParameter("dir3");

			String featureName4 = multi.getParameter("featureName4");
			String start4 = multi.getParameter("start4");
			String stop4 = multi.getParameter("stop4");
			String featureCategory4 = multi.getParameter("category4");
			String dir4 = multi.getParameter("dir4");

			String featureName5 = multi.getParameter("featureName5");
			String start5 = multi.getParameter("start5");
			String stop5 = multi.getParameter("stop5");
			String featureCategory5 = multi.getParameter("category5");
			String dir5 = multi.getParameter("dir5");

			String featureName6 = multi.getParameter("featureName6");
			String start6 = multi.getParameter("start6");
			String stop6 = multi.getParameter("stop6");
			String featureCategory6 = multi.getParameter("category6");
			String dir6 = multi.getParameter("dir6");
			
			String outputFile = "output" + hitNum + "_" + timeStr + ".txt";
			String inputFile = "input" + hitNum + "_" + timeStr + ".txt";
			//System.out.println(options.length);
			//if(mapTitle == null || mapTitle.length() == 0)
			//mapTitle = "Untitle";

			PlasFeatures plasFeature = null;

			if (sequence == null || sequence.length() == 0) {
				Enumeration files = multi.getFileNames();
				while (files.hasMoreElements()) {
					String name = (String) files.nextElement();
					File file = multi.getFile(name);
					plasFeature =
						new PlasFeatures(
							true,
							"",
							file.getPath(),
							tmpDir + inputFile,
							tmpDir + outputFile);
					//file.delete();

				}
			} else
				plasFeature =
					new PlasFeatures(
						false,
						sequence,
						"",
						tmpDir + inputFile,
						tmpDir + outputFile);

			Vector origin = plasFeature.getOrigin();
			Vector promoter = plasFeature.getPromoter();
			Vector regular = plasFeature.getRegulatorySeq();
			Vector tag = plasFeature.getTag();
			Vector terminator = plasFeature.getTerminator();
			Vector select = plasFeature.getSelector();
			Vector reporter = plasFeature.getReporter();
			Vector other = plasFeature.getOther();
			int realSeqLen = plasFeature.getSeqLength();

			if (realSeqLen > 20000)
				response.sendRedirect(
					response.encodeRedirectURL(
						"/PlasMapper/jsp/error.jsp?msg=The sequence length cannot be longer than 20000"));

			Vector orfs = new Vector(10);
			if (orfLen != null && orfLen.length() != 0) {
				//orfs = plasFeature.getORFs(Integer.parseInt(orfLen), strands);
				orfs =
					plasFeature.getStartORFs(Integer.parseInt(orfLen), strands);
				System.out.println(orfs);
			}

			Vector locations = new Vector(10);

			//Add use defined feature first
			if (featureName1 != null && featureName1.length() != 0) {
				String error = "";

				if (Integer.parseInt(start1) > realSeqLen
					|| Integer.parseInt(start1) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature1 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop1) > realSeqLen
					|| Integer.parseInt(stop1) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature1 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				String temp = "0";

				if (!featureCategory1.equals("unique_restriction_site")
					&& !featureCategory1.equals("restriction_site"))
					temp = dir1;

				locations.add(
					new FeatureSite(
						Integer.parseInt(start1) - 1,
						Integer.parseInt(stop1),
						featureName1,
						temp));

			}
			//Add use defined feature first
			if (featureName2 != null && featureName2.length() != 0) {

				String error = "";

				if (Integer.parseInt(start2) > realSeqLen
					|| Integer.parseInt(start2) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature2 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop2) > realSeqLen
					|| Integer.parseInt(stop2) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature2 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				String temp = "0";

				if (!featureCategory2.equals("unique_restriction_site")
					&& !featureCategory2.equals("restriction_site"))
					temp = dir2;

				locations.add(
					new FeatureSite(
						Integer.parseInt(start2) - 1,
						Integer.parseInt(stop2),
						featureName2,
						temp));

			}

			//Add use defined feature first
			if (featureName3 != null && featureName3.length() != 0) {

				String error = "";

				if (Integer.parseInt(start3) > realSeqLen
					|| Integer.parseInt(start3) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature3 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop3) > realSeqLen
					|| Integer.parseInt(stop3) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature3 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				String temp = "0";

				if (!featureCategory3.equals("unique_restriction_site")
					&& !featureCategory3.equals("restriction_site"))
					temp = dir3;

				locations.add(
					new FeatureSite(
						Integer.parseInt(start3) - 1,
						Integer.parseInt(stop3),
						featureName3,
						temp));

			}

			//Add use defined feature first
			if (featureName4 != null && featureName4.length() != 0) {

				String error = "";

				if (Integer.parseInt(start4) > realSeqLen
					|| Integer.parseInt(start4) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature4 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop4) > realSeqLen
					|| Integer.parseInt(stop4) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature4 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				String temp = "0";

				if (!featureCategory4.equals("unique_restriction_site")
					&& !featureCategory4.equals("restriction_site"))
					temp = dir4;

				locations.add(
					new FeatureSite(
						Integer.parseInt(start4) - 1,
						Integer.parseInt(stop4),
						featureName4,
						temp));

			}
			//			Add use defined feature first
			if (featureName5 != null && featureName5.length() != 0) {

				String error = "";

				if (Integer.parseInt(start5) > realSeqLen
					|| Integer.parseInt(start5) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature5 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop5) > realSeqLen
					|| Integer.parseInt(stop5) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature5 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				String temp = "0";

				if (!featureCategory5.equals("unique_restriction_site")
					&& !featureCategory5.equals("restriction_site"))
					temp = dir5;

				locations.add(
					new FeatureSite(
						Integer.parseInt(start5) - 1,
						Integer.parseInt(stop5),
						featureName5,
						temp));

			}

			//			Add use defined feature first
			if (featureName6 != null && featureName6.length() != 0) {

				String error = "";

				if (Integer.parseInt(start6) > realSeqLen
					|| Integer.parseInt(start6) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The start position of user defined feature6 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				if (Integer.parseInt(stop6) > realSeqLen
					|| Integer.parseInt(stop6) <= 0) {
					error =
						"/PlasMapper/jsp/error.jsp?msg=The stop position of user defined feature6 is out of range";
					response.sendRedirect(response.encodeRedirectURL(error));
				}

				String temp = "0";

				if (!featureCategory6.equals("unique_restriction_site")
					&& !featureCategory6.equals("restriction_site"))
					temp = dir6;

				locations.add(
					new FeatureSite(
						Integer.parseInt(start6) - 1,
						Integer.parseInt(stop6),
						featureName6,
						temp));

			}

			for (int i = 0; options != null && i < options.length; i++) {

				int feature = Integer.parseInt(options[i]);

				//System.out.println("feature=" + feature);

				if (feature == 1) {
					for (int j = 0; j < origin.size(); j++) {
						FeatureSite site = (FeatureSite) origin.elementAt(j);
						locations.add(site);
					}
					//System.out.println("location=" + locations.toString());
				} else if (feature == 2) {

					for (int j = 0; j < promoter.size(); j++) {
						FeatureSite site = (FeatureSite) promoter.elementAt(j);
						locations.add(site);

					}
				} else if (feature == 3) {

					for (int j = 0; j < terminator.size(); j++) {
						FeatureSite site =
							(FeatureSite) terminator.elementAt(j);

						locations.add(site);

					}
				} else if (feature == 4) {

					for (int j = 0; j < select.size(); j++) {
						FeatureSite site = (FeatureSite) select.elementAt(j);

						locations.add(site);

					}
				} else if (feature == 5) {

					for (int j = 0; j < reporter.size(); j++) {
						FeatureSite site = (FeatureSite) reporter.elementAt(j);

						locations.add(site);

					}
				} else if (feature == 6) {

					for (int j = 0; j < regular.size(); j++) {
						FeatureSite site = (FeatureSite) regular.elementAt(j);

						locations.add(site);

					}
				} else if (feature == 7) {

					for (int j = 0; j < tag.size(); j++) {
						FeatureSite site = (FeatureSite) tag.elementAt(j);

						locations.add(site);

					}
				} else if (feature == 8) {

					for (int j = 0; j < other.size(); j++) {
						FeatureSite site = (FeatureSite) other.elementAt(j);
						locations.add(site);

					}
				} else if (feature == 9) {
					Vector restrictionSites = null;
					Vector ncutters = new Vector(6);

					//unique site && common enzyme
					if (restriction.equals("1")) {
						//restrictionSites = plasFeature.getUniqueRestrictionSites(ncutters);

						restrictionSites =
							plasFeature.getUniqueRestrictionSites(1);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);
							
							locations.add(site);
						}
					}

					//unique with >= 4cutter
					else if (restriction.equals("2")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));

						Vector all = plasFeature.getUniqueRestrictionSites(1);
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}
					//unique site with >= 6cutter
					else if (restriction.equals("3")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));

						Vector all = plasFeature.getUniqueRestrictionSites(1);
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}

					//all site with common enzyme
					else if (restriction.equals("4")) {
						restrictionSites =
							plasFeature.getSite().getRestrictionSites(1);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}

					//all site with >= 4 cutter
					else if (restriction.equals("5")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));
						Vector all =
							plasFeature.getSite().getRestrictionSites(1);
						Vector useless =
							plasFeature.getSite().getRestrictionSites(
								ncutters,
								1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}

					}
					//all site with <= 6 cutter
					else if (restriction.equals("6")) {
						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));
						Vector all =
							plasFeature.getSite().getRestrictionSites(1);
						Vector useless =
							plasFeature.getSite().getRestrictionSites(
								ncutters,
								1);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}

					//unique site && all enzyme
					if (restriction.equals("7")) {
						//restrictionSites = plasFeature.getUniqueRestrictionSites(ncutters);

						restrictionSites =
							plasFeature.getUniqueRestrictionSites(0);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}

					//unique with >= 4cutter and all enzyme
					else if (restriction.equals("8")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));

						Vector all = plasFeature.getUniqueRestrictionSites(0);
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}
					//unique site with >= 6cutter
					else if (restriction.equals("9")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));

						Vector all = plasFeature.getUniqueRestrictionSites(0);
						Vector useless =
							plasFeature.getUniqueRestrictionSites(ncutters, 0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}

					//all site with common enzyme
					else if (restriction.equals("10")) {
						restrictionSites =
							plasFeature.getSite().getRestrictionSites(0);
						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}

					//all site with >= 4 cutter
					else if (restriction.equals("11")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						//ncutters.add(new Integer(4));
						Vector all =
							plasFeature.getSite().getRestrictionSites(0);
						Vector useless =
							plasFeature.getSite().getRestrictionSites(
								ncutters,
								0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}

					}
					//all site with <= 6 cutter
					else if (restriction.equals("12")) {

						ncutters.add(new Integer(1));
						ncutters.add(new Integer(2));
						ncutters.add(new Integer(3));
						ncutters.add(new Integer(4));
						ncutters.add(new Integer(5));
						//ncutters.add(new Integer(6));
						Vector all =
							plasFeature.getSite().getRestrictionSites(0);
						Vector useless =
							plasFeature.getSite().getRestrictionSites(
								ncutters,
								0);
						restrictionSites = removeUselessElement(all, useless);

						for (int j = 0; j < restrictionSites.size(); j++) {
							FeatureSite site =
								(FeatureSite) restrictionSites.elementAt(j);

							locations.add(site);
						}
					}
					
					//System.out.println("site start=" + site.getStart() + " end=" + site.getEnd()+ " label=" + site.getLabel());
					System.out.println("site" + locations.toString());
				}
			}
			for (int j = 0; j < orfs.size(); j++) {

				FeatureSite site = (FeatureSite) orfs.elementAt(j);

				for (int i = 0; strands != null && i < strands.length; i++) {

					int strand = Integer.parseInt(strands[i]);

					if (strand == Integer.parseInt(site.getDirection())) {
						locations.add(site);
					}
				}
			}
			locations = FeatureSite.bubbleSort(locations, locations.size());
			//System.out.println(locations);

			PlasmidTool tool = new PlasmidTool(plasFeature.getSequence());
			String textMap = tool.getSeqTextOutput(locations);

            /* BioMoby Integration Changes Start Here */
            String biomoby = multi.getParameter("biomoby");
            if (biomoby == null)
            {
                response.setContentType("text/html");
                PrintWriter out = response.getWriter();
    
                out.println(
                    "<HTML><HEAD><TITLE>Plasmid Text Map</TITLE>"
                        + "</HEAD><BODY><pre>"
                        + textMap
                        + "</pre></BODY></HTML>");
                out.close();
            }
            else
            {
                response.setContentType("text/plaintext");
                PrintWriter out = response.getWriter();
                out.println(textMap);
                out.close();
            }
            /* BioMoby Integration Changes End Here */

			//PrintWriter out = response.getWriter();
			//out.println(buffer.toString());

		} catch (java.lang.Exception ex) {
			ex.printStackTrace();
			ex.getMessage();
		}

	}
	protected void doGet(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {

		doPost(request, response);
	}

	private Vector removeUselessElement(Vector all, Vector partial) {

		Vector left = new Vector(10);

		for (int i = 0; i < all.size(); i++) {

			FeatureSite site = (FeatureSite) all.elementAt(i);
			String name = site.getLabel();

			boolean found = false;

			for (int j = 0; j < partial.size(); j++) {

				FeatureSite temp = (FeatureSite) partial.elementAt(j);

				if (name.equals(temp.getLabel()))
					found = true;

			}

			if (!found)
				left.add(site);
		}

		return left;

	}

}
